// Copyright (c) 2024 Codemongous LLC. All Rights Reserved.

#pragma once
#include "ISCW_UK2Node.h"

#include <memory>
#include <string>

using std::shared_ptr;
using std::wstring;

namespace Sourcify
{
	class ISCW_UEnum;
	class ISCW_UK2Node_ForEachElementInEnum : public virtual ISCW_UK2Node
	{
	public:
		virtual ~ISCW_UK2Node_ForEachElementInEnum() = default;

		virtual shared_ptr<ISCW_UEnum> GetEnum() const = 0;

		virtual void ReloadEnum(shared_ptr<ISCW_UEnum> InEnum) = 0;
		
		virtual std::shared_ptr<ISCW_UK2Node_ForEachElementInEnum> ToUK2Node_ForEachElementInEnumPtr() = 0;
		virtual std::shared_ptr<const ISCW_UK2Node_ForEachElementInEnum> ToUK2Node_ForEachElementInEnumPtr() const = 0;
	};

	using ISCW_UK2Node_ForEachElementInEnumConstPtr = std::shared_ptr<const ISCW_UK2Node_ForEachElementInEnum>;
	using ISCW_UK2Node_ForEachElementInEnumPtr = std::shared_ptr<ISCW_UK2Node_ForEachElementInEnum>;
} // namespace Sourcify